/*
first test at drawing a background and probably some sprites.

*/


#include <gb/gb.h>
#include <stdio.h>
#include "tiles.h"

#define ammo_amount 5
#define ammo_sprite_start 4
#define ammo_draw_y  20

#define monster_amount 3


int player_x, player_y; 
int ammo_x[ammo_amount], ammo_y[ammo_amount];
int monster_x[monster_amount], monster_y[monster_amount];
int shootWasDown;
//variables that will be able to be set by a shop system, if it were ever to be implemented
int ammo_speed = 2;
int monster_speed = 2;
int lives = 3, score = 0;
void printNumber(int number);

void resetAmmoDraw(int ammo){

	

	ammo_x[ammo]= 20 + ammo*10;
	
	ammo_y[ammo] = ammo_draw_y; 
	
	move_sprite(ammo_sprite_start+ammo,ammo_x[ammo],ammo_y[ammo]);  
//move_sprite(4,8,8);  
}



void initAmmo(){




int i;
	for( i = 0; i < ammo_amount; i++){
	
		set_sprite_tile( ammo_sprite_start + i,ammo_sprite_start);	
	
		resetAmmoDraw(i);
	
	
	
	
	}
	
	


}


void initPlayer(){

	shootWasDown = 0;
	player_x = 20; player_y = 20;

	//set the player sprites
	
	set_sprite_tile(0,0);                 
	set_sprite_tile(1,1); 
	set_sprite_tile(2,2);  
	set_sprite_tile(3,3);
	
}
void resetMonster(int i){
monster_x[i] = 200;
monster_y[i] = 40 + 20*i;
move_sprite(9 + i,monster_x[i], monster_y[i]);
}

void initMonster(){
	int i;
	
	for(i = 0; i < monster_amount; i++){
		set_sprite_tile(9+i,5);    
		resetMonster(i);
		
		
		
		
		
	}

}



void startAmmoShoot(){
int i;

	
	for(i = 0; i < ammo_amount;i++){

		if(ammo_y[i] == ammo_draw_y){
			
		
			
			ammo_x[i] = player_x;
			ammo_y[i] = player_y;
		
			move_sprite(ammo_sprite_start+i,ammo_x[i],ammo_y[i]);
			
			break;
		
		}
	

	}

	delay(20);
	
}

void draw16x16(int start, int x, int y){

move_sprite(start,x,y);  
 move_sprite(start+1,x,y+8);
 move_sprite(start+2,x+8,y);
 move_sprite(start+3,x+8,y+8);

}
void printNumber(int number){

if(number >9)
	printNumber(number/10);

	number = number%10;
	
	if(number == 0)
		printf("0");

	if(number == 1)
		printf("1");
	if(number == 2)
		printf("2");
	if(number == 3)
		printf("3");
	if(number == 4)
		printf("4");
	if(number == 5)
		printf("5");
	if(number == 6)
		printf("6");
	if(number == 7)
		printf("7");	
	if(number == 8)
		printf("8");
	if(number == 9)
		printf("9");
		
}

void handleAmmoLogic(){
int i;

	
	for(i = 0; i < ammo_amount;i++){

		if(ammo_y[i] == ammo_draw_y)
			continue;
		
		ammo_x[i]+= ammo_speed;
		if(ammo_x[i] > 200){
			ammo_x[i]= 20 + i*10;
			ammo_y[i] = ammo_draw_y; 
		}
	
		move_sprite(ammo_sprite_start+i,ammo_x[i],ammo_y[i]);
		
	}


}


handleMonsterLogic(){
	int i; 
	int j;
	for(i = 0; i < monster_amount; i++){
	
		monster_x[i] -= monster_speed;
		move_sprite(9 + i,monster_x[i], monster_y[i]);
		
		
		if(monster_x[i] < 0){
			lives--;
			resetMonster(i);
			continue;
		}
	
		for(j = 0; j < ammo_amount;j++){

		if(ammo_y[j] == ammo_draw_y)
			continue;
			
		if(ammo_y[j] > monster_y[i] + 8)
			continue;
		if(ammo_y[j] + 8	< monster_y[i] )
			continue;
		if(ammo_x[j] > monster_x[i] + 8)
			continue;
		if(ammo_x[j] + 8	< monster_x[i] )
			continue;
			
		resetMonster(i);
		score++;
		resetAmmoDraw(j);
		
		}
		
	}



}

void main(){
	int key;
	
	
	set_sprite_data(0,6,sprt); 

 SHOW_SPRITES;
 
	printf("Welcome to my game. Move up and down. release a to shoot. don't let any monsters get past you. if you let 3 past you, you lose. press start to begin");
	waitpad(J_START);
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
 
 
	initAmmo();
	initPlayer();
	initMonster();
	


 
	wait_vbl_done();     

 

//the sprite starts at 0. if everything is 16x16, it would be very easy to just add +4 every time
  
	
 
 
  draw16x16(0,player_x,player_y);
  
  
  while(1){
  
  if(lives == 0){
	for(key = 0; key < 4 + ammo_amount + monster_amount; key++){
		move_sprite(key,200,200);
		
	}
	printf("game over. your score was: ");
	printNumber(score);
	printf("\n\n\n\nPress start to reset the game");
  break;
  }
  
  //HANDLE INPUTLESS LOGIC
  handleAmmoLogic();
  handleMonsterLogic();
  
  
/////////HANDLE INPUT
	key=joypad();				//set key with the current joypad value(Button up, down, A...)
    if(key & J_UP){	
		if(player_y > 29){//if the up pad is pressed
		player_y-=1;				//reduce y by one
		draw16x16(0,player_x,player_y);//move current sprite 1 point up
		}
    }
	//key=joypad();				//set key with the current joypad value(Button up, down, A...)
    if(key & J_DOWN){	//if the up pad is pressed
		
		if(player_y < 142){
			player_y+=1;				//reduce y by one
		draw16x16(0,player_x,player_y);//move current sprite 1 point up
		}
    }
	//key=joypad();				//set key with the current joypad value(Button up, down, A...)
    if(key &	J_A){			//if the up pad is pressed
		
			shootWasDown = 1;
		
    }else{
		if(shootWasDown){	
			startAmmoShoot();
			shootWasDown = 0;
		}
	}
	
	delay(20);				
  }
 
 

	waitpad(J_START);
	reset();

 //move_sprite(0,10,20); 
}
